;
;       Patch de l'AES pour le Programme/Accessoire GemSight
;       
;

APPL_WRITE      equ     $0C
CALL_AES        equ     $C8
NOEXTENDED      equ     $00

FlagGS          equ     $8000                           ; Message catched
NFlagGS         equ     $7FFF

; Importation/Exportation datas between Assembly/C code

		.EXPORT 	oldaes                  ; @ Aes standard
		.EXPORT 	newaes                  ; @ Patch Aes
		
		.IMPORT 	AesHandle               ; PID de GemSight

; Marquage du Patch norme XBRA

		dc.l    	'XBRA'
		dc.l    	'GEMSIGHT'              ; Application name
		
oldaes:         dc.l 		0

Type:		dc.l		0
Mess_2:		dc.l		0
PID_d:		dc.l		0

;
; Catch appl_write() call to execute this new programme before
;
newaes:
		cmp.w           #CALL_AES,d0            ; Est ce un appel  l'AES ?
		bne		Recall                  ; Non, Sauter ancienne adresse
		move.l          d1,a0                   ; Rcuprer adresse params
		cmp.w           #APPL_WRITE,([a0])      ; Est ce un appl_write() ?
		bne             Recall                  ; Non, Sauter ancienne adresse
;
; Compute Type, PID_d and Mess_2 addresses
;
;	Type is the message type
;	PID_d is the application destination's address
;	Mess_2 is the Message[2] location

		add.l		#8,a0			; Go to intin pointer
		move.l		(a0),PID_d		; Get address of PID_d
		add.l		#8,a0			; Go to addrin pointer
		move.l		([a0]),a0
		move.l		a0,Type			; Type message's address
		addq.l		#4,a0
		move.l		a0,Mess_2		; Mess[2]'s address

;        
; Change message to send it to GemSight
;

Change:	        move.l		Type,a0
		move.w          (a0),d0                 ; Copy Message Type
		and.w           #FlagGS,d0              ; Testing FlagGS bit;
		bne.s           UnChange                ; If set...
		
		move.l		PID_d,a0
		move.w		(a0),d0
		cmp.w           AesHandle,d0            ; Message to gemSight
		beq.s           UnChange

		move.l		Mess_2,a0
		cmpi.w          #NOEXTENDED,(a0)	; If not an extend message
		bne.s           UnChange

		move.l		PID_d,a0
		move.l		a1,-(sp)
		move.l		Mess_2,a1
		move.w          (a0),(a1)
		move.w          AesHandle,(a0)		; write our PID
		move.l		Type,a0
		or.w            #FlagGS,(a0)		; Set FlagGS bit
		move.l		(sp)+,a1
		

		bra.s           Letsgo                  ; Call AES

;
; Change message to send it to original application
;

UnChange:       move.l		Type,a0
		move.w          (a0),d0
		and.w           #FlagGS,d0              ; Testing flag bit
		beq.s           Letsgo                  ; If no set...

		move.l		PID_d,a0
		move.l		a1,-(sp)
		move.l		Mess_2,a1
		move.w          (a1),(a0)		; original PID
		move.l		Type,a0
		and.w           #NFlagGS,(a0)           ; FlagGS bit to 0
		move.w          #NOEXTENDED,(a1)	; No extended message
		move.l		(sp)+,a1
;
; Call Original Aes (Replace Aes code function if necessary)
;

Letsgo:         move.w          #CALL_AES,d0            ; Replace Aes code call

Recall:         jmp             ([oldaes])              ; Saut dans l'AES...(never return!)

		

